#!/usr/bin/gawk -f
BEGIN{
  InputCommand[0x80];
  InputCommandNum[0x80];
  InputCommandFun[0x80];
  InputArgumentFlag = 0;
  InputArgumentCount[0x80];
  InputArgumentMaxCount = 0;
  InputArgumentType[0x80,0x80];
  OutputArgumentFlag = 0;
  OutputArgumentCount[0x80];
  OutputArgumentType[0x80,0x80];
  OutputArgumentMaxCount = 0;
  BlockNum = 0;
  StructureFlag = 0; #0 => new structure, 1 => this structure
  CommandCount = 0;
  i = 0;
}

function StrToNum(String)
{
	if((length(String) == 1) && (String == "0")){
		return 0;
	}else{
		return strtonum(String);
	}
}

{
if(NR == FNR) #Process file1
  {
    if($1 == "#define" && match($3,"[0-9]") && (StructureFlag == 0))
	{
	    BlockNum++;
	    InputCommand[BlockNum] = $2;
		InputCommandNum[BlockNum] = $3;
	    #printf("%x\n", $3);
	}
	
	if($1 == "typedef")
	{
	    StructureFlag = 1;
		
	    if(match($3,".*_OUT"))
	    {
          OutputArgumentFlag = 1;
		  InputArgumentFlag = 0;
	    }
	    if(match($3,".*_IN"))
	    {
          InputArgumentFlag = 1;
		  OutputArgumentFlag = 0;
	    }
	}
	
	if( (StructureFlag == 1) && (OutputArgumentFlag == 1 || InputArgumentFlag == 1))
	{
	     $1 = tolower($1);
		 $2 = tolower($2);
	     if(OutputArgumentFlag == 1)
		 {

		    if (match($1,"^boolean$|^uchar$|^ushort$|^ulong$|^ulonglong$|^char$") || ($1 == "//" && match($2,"^boolean$|^uchar$|^ushort$|^ulong$|^ulonglong$|^char$")))
			{
			   OutputArgumentCount[BlockNum]++;
			   if (match($1,"^boolean$|^uchar$") || ($1 == "//" && match($2,"^boolean$|^uchar$")))
			   {
			      OutputArgumentType[BlockNum,OutputArgumentCount[BlockNum]] = "HexUint8";
			   }
			   if (match($1,"^ushort$") || ($1 == "//" && match($2,"^ushort$")))
			   {
			      OutputArgumentType[BlockNum,OutputArgumentCount[BlockNum]] = "HexUint16";
			   }
			   if (match($1,"^ulong$") || ($1 == "//" && match($2,"^ulong$")))
			   {
			      OutputArgumentType[BlockNum,OutputArgumentCount[BlockNum]] = "HexUint32";
			   }
			   if (match($1,"^ulonglong$") || ($1 == "//" && match($2,"^ulonglong$")))
			   {
			      OutputArgumentType[BlockNum,OutputArgumentCount[BlockNum]] = "HexUint64";
			   }
			   if (match($1,"^char$") || ($1 == "//" && match($2,"^char$")))
			   {
			      OutputArgumentType[BlockNum,OutputArgumentCount[BlockNum]] = "UnicodeString";
			   }
			}
			#if(OutputArgumentCount[BlockNum] > OutputArgumentMaxCount) OutputArgumentMaxCount = OutputArgumentCount[BlockNum];
		 }
		 
		 if(InputArgumentFlag == 1)
		 {
		    if (match($1,"^boolean$|^uchar$|^ushort$|^ulong$|^ulonglong$|^char$") || ($1 == "//" && match($2,"^boolean$|^uchar$|^ushort$|^ulong$|^ulonglong$|^char$")))
			{
			   InputArgumentCount[BlockNum]++; #awk file need to start with "1",otherwise noneffective
			   if (match($1,"^boolean$|^uchar$") || ($1 == "//" && match($2,"^boolean$|^uchar$")))
			   {
			      InputArgumentType[BlockNum,InputArgumentCount[BlockNum]] = "HexUint8";
			   }
			   if (match($1,"^ushort$") || ($1 == "//" && match($2,"^ushort$")))
			   {
			      InputArgumentType[BlockNum,InputArgumentCount[BlockNum]] = "HexUint16";
			   }
			   if (match($1,"^ulong$") || ($1 == "//" && match($2,"^ulong$")))
			   {
			      InputArgumentType[BlockNum,InputArgumentCount[BlockNum]] = "HexUint32";
			   }
			   if (match($1,"^ulonglong$") || ($1 == "//" && match($2,"^ulonglong$")))
			   {
			      InputArgumentType[BlockNum,InputArgumentCount[BlockNum]] = "HexUint64";
			   }
			   if (match($1,"^char$") || ($1 == "//" && match($2,"^char$")))
			   {
			      InputArgumentType[BlockNum,InputArgumentCount[BlockNum]] = "UnicodeString";
			   }
			}
			#if(InputArgumentCount[BlockNum] > InputArgumentMaxCount) InputArgumentMaxCount = InputArgumentCount[BlockNum];
		 }
	}
	
	if((match($3,".*;")) && (StructureFlag == 1))
	{
	    StructureFlag = 0;
		OutputArgumentFlag = 0;
		InputArgumentFlag = 0;
	}
  } #End of process file1
  
  if(NR != FNR) #Process file2
  {  
     i = 1;
     while(InputCommandNum[i] != NULL )
	 {
	    
		#printf("%s (%x)\n",$1,StrToNum($1));
		if (StrToNum($1) == StrToNum(InputCommandNum[i]))
		{
		   CommandCount++;
		   InputCommandFun[i] = StrToNum($3);
		   if(InputArgumentCount[i] > InputArgumentMaxCount) InputArgumentMaxCount = InputArgumentCount[i];
		   if(OutputArgumentCount[i] > OutputArgumentMaxCount) OutputArgumentMaxCount = OutputArgumentCount[i];
		}
		i++;
	 }
  }
}
END {

	
  if(NR != FNR) #After process file2, output the final file.
   {
    
	printf("InputArgumentCount %d\nOutputArgumentCount %d\nCommandCount %d\n",InputArgumentMaxCount,OutputArgumentMaxCount,CommandCount);
    
	i = 1;
	while(InputCommand[i] != NULL )
	{
	    if(InputCommandFun[i] != NULL)
		{
		 printf("\n%s\n",InputCommand[i]);
		 printf("%x\n",InputCommandFun[i]);
		
		 printf("%d ",InputArgumentCount[i]);
		 for(j = 1; j <= InputArgumentMaxCount;j++)
		 {
           if (InputArgumentType[i,j] != NULL)
		     printf("%s ",InputArgumentType[i,j]);
		   else
		     printf("Undefined ");
		 }
		
		 printf("\n%d ",OutputArgumentCount[i]);
		 for(j = 1; j <= OutputArgumentMaxCount;j++)
		 {
		   if (OutputArgumentType[i,j] != NULL)
		     printf("%s ",OutputArgumentType[i,j]);
		   else
		     printf("Undefined ");
		 }
		
		 printf("\n%s",InputCommand[i]);
		 for(k = 1; k < 24-length(InputCommand[i]); k++)
		    printf(" ");
		 printf(": ");
		 for (k = 1; k <= InputArgumentCount[i] ; k++)
		 {
		   printf("[IN ]%s",InputArgumentType[i,k]);
		   for(l = 1; l < 16-length(InputArgumentType[i,k]); l++)
		    printf(" ");
		 }
		 for (k = 1; k <= OutputArgumentCount[i] ; k++)
		 {
		   printf("[OUT]%s",OutputArgumentType[i,k]);
		   for(l = 1; l < 16-length(OutputArgumentType[i,k]); l++)
		    printf(" ");
		 }
		 printf("\n");
		 
		}
		i++;
	}
   }
   else printf("%s",$1); #Temp
}
