// WMI.cpp : Defines the entry point for the console application.
//
#include "stdafx.h"
#include <windows.h>
#include <fstream>
#include <iostream>
#include "WmiBufferCal.h"
using namespace std;
int CmdCount;
int InDataCount;
int OutDataCount;

typedef struct _InputFormat{
	    char argvString[0x80];
		DWORD   Func;
		INPUT_BUFF_FORMAT    InputArgc;
		OUTPUT_BUFF_FORMAT   OutputArgc;
		char helpstring[0x80];
 };
  _InputFormat InputFormat[0x20];
 
VOID ShowHelpMessage()
{
	//printf(" ----------------------------------------------------------------------------\n");
	printf(" Command   FunctionList \n");
	printf(" ------------------------------------------------------------------------------\n");
	
	for (int Index = 0; Index < CmdCount; Index ++)
	{
		int CharIndex = 0;
		while(InputFormat[Index].helpstring[CharIndex])
		{
		      printf("%c",InputFormat[Index].helpstring[CharIndex]);
			  CharIndex ++;
		}
		cout << endl;
	}
}

int DetectCmd(int argc, CHAR* argv[])
{
    char argvString[0x80];
    if(argc >= 2)
      StringToLower(argv[1], argvString);
	
	for (int Index = 0; Index < CmdCount; Index ++)
	{
		if (strcmp(argvString, InputFormat[Index].argvString)==0)
			return Index;
	}

	return -1;
}

int DetectInput(IN char *InputString, FORMATLIST InputFormat)
{
    int StringSize = strlen(InputString);
	switch (InputFormat)
	{
	case UnicodeString:
		if (StringSize < 0x30) return 1;
		break;
	case HexUint8:
		if (StringSize <= 2) return 1;
		break;
	case HexUint16:
		if (StringSize <= 4) return 1;
		break;
	case HexUint32:
		if (StringSize <= 8) return 1;
		break;
	case HexUint64:
		if (StringSize <= 16) return 1;
		break;
	default:
		return 1;
		break;
	}
	return 0;
}


VOID ShowInputInfo(int argc, CHAR* argv[])
{
	int CharIndex = 0;

	for (int Index = 1; Index < argc; Index ++)
	{
		if (Index == 1)
			printf("  Command = ");
		else printf(",  Argv[%d] = ",Index);
		for (int  StringIndex = 0; StringIndex < strlen(argv[Index]); StringIndex ++)
		{
			printf("%c",argv[Index][StringIndex]);
		}
	}
	printf("\n");
}

FORMATLIST ConvertToEnum(IN char *InputString)
{
	//printf("convert %s, %d\n",InputString,strlen(InputString));
	if (strcmp(InputString, "UnicodeString")==0)
	{
		return UnicodeString;
	}
	if (strcmp(InputString, "HexUint8")==0)
	{
		return HexUint8;
	}
	if (strcmp(InputString, "HexUint16")==0)
	{
		return HexUint16;
	}
	if (strcmp(InputString, "HexUint32")==0)
	{
		return HexUint32;
	}
		if (strcmp(InputString, "HexUint64")==0)
	{
		return HexUint64;
	}
	if (strcmp(InputString, "Undefined")==0)
	{
		return Undefined;
	}
	return Undefined;
}

int ImportWMIInterface()
{
  ifstream Input;
  Input.open("WmiInterface.txt");
  if(!Input.good()) 
	  {
		  cout<<"WmiInterface.txt not exist. Please run WMI_Init.bat first.\n";
		  return 0;
      }

  int i = 0;
  int temp = 0;
  char InputString[0x50],OutputString[0x50];

  Input >> InputString >> InDataCount;
  Input >> InputString >> OutDataCount;
  Input >> InputString >> CmdCount;
  Input >> ws;

  for(int i=0; i < CmdCount; i++) 
  {
	  InputFormat[i].InputArgc.FormatBuff = new FORMATLIST[InDataCount];
	  InputFormat[i].OutputArgc.FormatBuff = new FORMATLIST[OutDataCount];

	  Input.getline(InputFormat[i].argvString,sizeof(char)*0x80);
	  StringToLower(InputFormat[i].argvString, InputFormat[i].argvString);
      Input >>hex>> InputFormat[i].Func ;

	  Input >>  InputFormat[i].InputArgc.DataCount;
	  
	  for(temp = 0; temp < InDataCount; temp++)
	  {
		  Input >> InputString;
		  InputFormat[i].InputArgc.FormatBuff[temp] = ConvertToEnum(InputString);
		  //cout << InputFormat[i].InputArgc.FormatBuff[temp] <<endl;
	  }

	  Input >>  InputFormat[i].OutputArgc.DataCount;
	  for(temp = 0; temp < OutDataCount; temp++)
	  {
		  Input >> OutputString;
		  InputFormat[i].OutputArgc.FormatBuff[temp] = ConvertToEnum(OutputString);
		  //cout << InputFormat[i].OutputArgc.FormatBuff[temp] <<endl;
	  }

	  Input >>ws;
      Input.getline(InputFormat[i].helpstring,sizeof(char)*0x80);
	  Input >>ws;
      //i++;
  }

  Input.close();
  return 1;
}

int main(int argc, CHAR* argv[])
{
  DWORD   ACPIAddr,RSDTAddr,FACPAddr,DSDTAddr,WmiBufferAddr =0;
  WMI_RMT_BUFF WmiBufferData;
  int Index = 0,  Status = 1;
  
  if(ImportWMIInterface() == 0) return 0;
  InitMem();
  memset(&WmiBufferData,0,sizeof(WMI_RMT_BUFF));
  ACPIAddr = GetACPITable();
  RSDTAddr = GetRSDTTable(ACPIAddr);
  FACPAddr = GetFACPTable(RSDTAddr);
  DSDTAddr = GetDSDTTable(FACPAddr);
  WmiBufferAddr = GetWmiBufferAddr(DSDTAddr);
  printf("\n ------------------------------------------------------------------------------\n");


  
  int DetectCmdResult = DetectCmd(argc, argv);
  if (DetectCmdResult != -1)
  {
    ShowInputInfo(argc, argv);
	if (argc < InputFormat[DetectCmdResult].InputArgc.DataCount + 2)
    {
			  printf("\n  Missing Parameters!\n");
    }
	else if (argc > InputFormat[DetectCmdResult].InputArgc.DataCount + 2)
	{
			  printf("\n  Too many Parameters!\n");
	}
	else
	{
	  //Process /GetLastError
	  if (InputFormat[DetectCmdResult].Func == 0)
	  {
		  GetLastError(WmiBufferAddr);
		  goto exit;
	  }

	  //Process others CMD
	  char (*StringBuff)[0x70] = new char[InDataCount][0x70];
	 

	  WmiBufferData.Func = InputFormat[DetectCmdResult].Func;
			  
	  for (Index = 0; Index < InputFormat[DetectCmdResult].InputArgc.DataCount; Index ++)
	  {
		 memset(StringBuff[Index],0,sizeof(char)*0x70);
		 if ( DetectInput(argv[2 + Index], InputFormat[DetectCmdResult].InputArgc.FormatBuff[Index] )==0 )
		 {
			 printf("\n  Parameter Error.\n");
			 goto exit;
		 }

		 if ( !strcmp(argv[2 + Index] , "''" ))
		 {
				  StringBuff[Index][0] = '\0';
		 }
		 else strcpy(StringBuff[Index],argv[2 + Index]);
		 //printf("Test[%d] %s",Index,StringBuff[Index]);
       }
	   Status = StringConvert(StringBuff,  InputFormat[DetectCmdResult].InputArgc , WmiBufferData.InputData);
	   if (Status == 0)
	   {
		   goto exit;
	   }
	   SetAndGetWmiBufferWithFormat(WmiBufferAddr, InputFormat[DetectCmdResult].InputArgc, &WmiBufferData);
			
	   //Process Output 
	   if((InputFormat[DetectCmdResult].OutputArgc.DataCount == 1) && (WmiBufferData.Status == 0))
       {
		  printf("\n  Output  = ");
		  if (InputFormat[DetectCmdResult].OutputArgc.FormatBuff[0] >=1 && InputFormat[DetectCmdResult].OutputArgc.FormatBuff[0] <=8) //FormatBuff[Count] in {HexUint8=1,HexUint16=2,HexUint32=4,HexUint64=8}
		  {
			  for(int i = 0; i < InputFormat[DetectCmdResult].OutputArgc.FormatBuff[0]; i++)
		        printf("%02x",WmiBufferData.OutputData[i]);
			  printf("\n");
		  }
		  else if(InputFormat[DetectCmdResult].OutputArgc.FormatBuff[0] == UnicodeString)
		  {
			   char OutputString[0x80];
			   UnicodeStringToString(WmiBufferData.OutputData,OutputString);
			   for(int i = 0; i < strlen(OutputString); i++)
			   {
		           printf("%c",OutputString[i]);
               }
	           printf("\n");
		  }
		}
	   delete []StringBuff;
	}//end of argc processing
  }//End of if (DetectCmdResult != -1)
  else ShowHelpMessage();

exit:
  ReleaseMem();
  //for(i=0; i < CmdCount; i++) delete [] InputFormat[i].InputArgc.FormatBuff;
  for(int i=0; i < CmdCount; i++) 
  {
	  delete [] InputFormat[i].InputArgc.FormatBuff;
	  delete [] InputFormat[i].OutputArgc.FormatBuff;
  }
  printf("\n ------------------------------------------------------------------------------\n");
  return 0;
}
 


